      PROGRAM MAIN
C
C         Notice of Public Domain nature of MOPAC
C
C      'This computer program is a work of the United States
C       Government and as such is not subject to protection by
C       copyright (17 U.S.C. # 105.)  Any person who fraudulently
C       places a copyright notice or does any other act contrary
C       to the provisions of 17 U.S. Code 506(c) shall be subject
C       to the penalties provided therein.  This notice shall not
C       be altered or removed from this software and is to be on
C       all reproductions.'
C
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'SIZES'
      COMMON /SCFTYP/ EMIN, LIMSCF
      COMMON /KEYWRD/ KEYWRD
      COMMON /OKMANY/ ISOK
      COMMON /GEOVAR/ NVAR,LOC(2,MAXPAR), IDUMY, XPARAM(MAXPAR)
      COMMON /MESAGE/ IFLEPO,ISCF
      COMMON /GEOSYM/ NDEP,LOCPAR(MAXPAR),IDEPFN(MAXPAR),LOCDEP(MAXPAR)
      COMMON /GEOKST/ NATOMS,LABELS(NUMATM),
     1NA(NUMATM),NB(NUMATM),NC(NUMATM)
      COMMON /GEOM  / GEO(3,NUMATM)
      COMMON /REFXYZ/ XYZ(3,NUMATM)
      COMMON /GRADNT/ GRAD(MAXPAR),GNORM
      COMMON /MOLKST/ NUMAT,NAT(NUMATM),NFIRST(NUMATM),NMIDLE(NUMATM),
     1                NLAST(NUMATM), NORBS, NELECS,NALPHA,NBETA,
     2                NCLOSE,NOPEN,NDUMY,FRACT
      COMMON /EXTPC / IPCUSE,NPC,PCX(4,10000),NATPC(10000)
      COMMON /ATHEAT/ ATHEAT
      COMMON /LAST  / LAST
      COMMON /ATOMIC/ EISOL(107),EHEAT(107)
      COMMON /NUMCAL/ NUMCAL
      COMMON /TIME  / TIME0
      COMMON /PATH  / LATOM,LPARAM,REACT(200)
C
C Cepos extension to assign file names
C
      common /files / file_names(22),namelen(22)

      DIMENSION COORD(3*NUMATM)
      DIMENSION U(3,3),T(3),XYZNEW(3)
      CHARACTER*241 KEYWRD
C
C Cepos extension to assign file names
C
      character*80 file_names
      LOGICAL ISOK, LIMSCF
C
C Cepos section to get input file name and assign the array of file names
C               and lengths.
C
      call get_arguments(1,file_names(1),namelen(1))

      call filenames
C
C Cepos section: Open input and output files
C
      call file_open(5)
      call file_open(6)


      NUMCAL=0
      ISOK=.TRUE.
   10 NUMCAL=NUMCAL+1
C
      TIME0=SECOND()
C
C READ AND CHECK INPUT FILE, EXIT IF NECESSARY.
C     WRITE INPUT FILE TO UNIT 6 AS FEEDBACK TO USER
C
   20 CALL READ
      EMIN=0.D0
C#      CALL TIMER('AFTER READ')
      IF(NATOMS.EQ.0) GOTO 50
      IF(INDEX(KEYWRD,'AUTHOR') .NE. 0) THEN
         WRITE(6,'(10X,'' MOPAC - A GENERAL MOLECULAR ORBITAL PACKAGE'',
     1/         ,10X,''   ORIGINAL VERSION WRITTEN IN 1983'')')
         WRITE(6,'(10X,''     BY JAMES J. P. STEWART AT THE'',/
     1         ,10X,''     UNIVERSITY OF TEXAS AT AUSTIN'',/
     2         ,10X,''          AUSTIN, TEXAS, 78712'')')
         WRITE(6,'(10X,''  MODIFIED TO DO ESP CALCULATIONS BY''
     1          ,10X,''    BRENT H. BESLER AND K. M. MERZ JR. 1989'')')
      ENDIF
      CALL PCREAD(NATOMS)
C
C INITIALIZE CALCULATION AND WRITE CALCULATION INDEPENDENT INFO
C
      IF(INDEX(KEYWRD,'0SCF') .NE. 0) THEN
         WRITE(6,'(A)')' GEOMETRY IN MOPAC Z-MATRIX FORMAT'
         CALL GEOUT(6)
         IF(INDEX(KEYWRD,' AIGOUT').NE.0)THEN
            WRITE(6,'(//,A)')'  GEOMETRY IN GAUSSIAN Z-MATRIX FORMAT'
            CALL WRTTXT(6)
            CALL GEOUTG(6)
         ENDIF
         GOTO 50
      ENDIF
      CALL MOLDAT(0)
      IF(INDEX(KEYWRD,'EXTERNAL') .NE. 0) THEN
         CALL DATIN
C
C  RECALCULATE THE ATOMIC ENERGY
C
         ATHEAT=0.D0
         EAT=0.D0
         DO 30 II=1,NUMAT
            NI=NAT(II)
            ATHEAT=ATHEAT+EHEAT(NI)
   30    EAT   =EAT   +EISOL(NI)
         ATHEAT=ATHEAT-EAT*23.061D0
      ENDIF
      IF (INDEX(KEYWRD,'RESTART').EQ.0)THEN
         IF (INDEX(KEYWRD,'1SCF').NE.0) THEN
            IF(LATOM.NE.0)THEN
               WRITE(6,'(//,10X,A)')'1SCF SPECIFIED WITH PATH.  THIS PAI
     1R OF'
               WRITE(6,'(   10X,A)')'OPTIONS IS NOT ALLOWED'
               GOTO 50
            ENDIF
            IFLEPO=1
            ISCF=1
            LAST=1
            I=INDEX(KEYWRD,'GRAD')
            DO 39 J=1,NVAR
  39        GRAD(J)=0.D0
C
C           molecule is being reoriented. determine the rotation
C           and translation involved by comparing the input
C           coordinates (on XYZ) against the actual coordinates
C           (on GEO) and apply them to the point charge coordinates.
C
            IF ( IPCUSE.EQ.1.AND.NPC.GT.0 ) THEN
               CALL SUPIMP(XYZ,GEO,NATOMS,U,T)
               DO 3890 IPC=1,NPC
                  DO 3891 J=1,3
                     XYZNEW(J)=U(1,J)*PCX(1,IPC)+
     1                         U(2,J)*PCX(2,IPC)+
     2                         U(3,J)*PCX(3,IPC)+T(J)
 3891                CONTINUE
                  DO 3892 J=1,3
                     PCX(J,IPC)=XYZNEW(J)
 3892                CONTINUE
 3890             CONTINUE
            ENDIF
C
            CALL COMPFG(XPARAM,.TRUE.,ESCF,.TRUE.,GRAD,I.NE.0)
C
C           energy could be recomputed here to obtain numerical
C           derivatives of energy wrt point charge coordinates
C
            IF ( IPCUSE.EQ.1 ) THEN
               OPEN(UNIT=13,FILE="MOPAC.PC.GRAD",FORM="FORMATTED")
               REWIND(13)
               WRITE(13,1300) ESCF
 1300          FORMAT(' ENERGY = ',F20.8,' KCAL/MOL')
               IF(I.EQ.0.OR.NVAR.NE.NATOMS*3-6) THEN
                  CLOSE(13)
                  GOTO 40
               ENDIF
               CALL GMETRY(GEO,COORD)
               XREF=COORD(1)
               YREF=COORD(2)
               ZREF=COORD(3)
               IF ( NATOMS.GT.1 ) THEN
                  COORD(1)=COORD(4)-XREF
               ENDIF
               IF ( NATOMS.GT.2 ) THEN
                  COORD(2)=COORD(7)-XREF
                  COORD(3)=COORD(8)-YREF
               ENDIF
               IF ( NATOMS.GT.3 ) THEN
                  K=3
                  DO 390 I=4,NATOMS
                     COORD(K+1) = COORD(K+7) - XREF
                     COORD(K+2) = COORD(K+8) - YREF
                     COORD(K+3) = COORD(K+9) - ZREF
  390                K=K+3
               ENDIF
               WRITE(13,1301) NVAR
 1301          FORMAT(' ATOMIC GRADIENTS (',I5,')')
               DO 391 IVAR=1,NVAR
                  WRITE(13,1302) IVAR,COORD(IVAR),GRAD(IVAR)
 1302             FORMAT(I5,F20.8,2X,F20.8)
  391             CONTINUE
               WRITE(13,1303) NPC
 1303          FORMAT(' POINT CHARGE GRADIENTS (',I5,')')
               DPC = 1.0D-04
               DPCHLF = 0.5*DPC
               DPCINV = 1.D+00/DPC
               DO 392 IPC = 1,NPC
                  PCX(1,IPC) = PCX(1,IPC) + DPCHLF
                  CALL COMPFG(XPARAM,.TRUE.,ESCFXP,.TRUE.,GRAD,.FALSE.)
                  PCX(1,IPC) = PCX(1,IPC) - DPC     
                  CALL COMPFG(XPARAM,.TRUE.,ESCFXM,.TRUE.,GRAD,.FALSE.)
                  PCX(1,IPC) = PCX(1,IPC) + DPCHLF
                  DERIVX = (ESCFXP - ESCFXM)*DPCINV
                  PCX(2,IPC) = PCX(2,IPC) + DPCHLF
                  CALL COMPFG(XPARAM,.TRUE.,ESCFYP,.TRUE.,GRAD,.FALSE.)
                  PCX(2,IPC) = PCX(2,IPC) - DPC     
                  CALL COMPFG(XPARAM,.TRUE.,ESCFYM,.TRUE.,GRAD,.FALSE.)
                  PCX(2,IPC) = PCX(2,IPC) + DPCHLF
                  DERIVY = (ESCFYP - ESCFYM)*DPCINV
                  PCX(3,IPC) = PCX(3,IPC) + DPCHLF
                  CALL COMPFG(XPARAM,.TRUE.,ESCFZP,.TRUE.,GRAD,.FALSE.)
                  PCX(3,IPC) = PCX(3,IPC) - DPC     
                  CALL COMPFG(XPARAM,.TRUE.,ESCFZM,.TRUE.,GRAD,.FALSE.)
                  PCX(3,IPC) = PCX(3,IPC) + DPCHLF
                  DERIVZ = (ESCFZP - ESCFZM)*DPCINV
                  WRITE(13,1304) IPC,DERIVX,DERIVY,DERIVZ
 1304             FORMAT(1X,I5,2X,F20.8,2X,F20.8,2X,F20.8)
  392             CONTINUE
               CLOSE(13)
            ENDIF
            GOTO 40
         ENDIF
      ENDIF
C
C CALCULATE DYNAMIC REACTION COORDINATE.
C
C
      IF(INDEX(KEYWRD,'SADDLE') .NE. 0) THEN
         CALL REACT1(ESCF)
         GOTO 50
      ENDIF
      IF(INDEX(KEYWRD,'STEP1') .NE. 0) THEN
         CALL GRID
         GOTO 50
      ENDIF
      IF (LATOM .NE. 0) THEN
C
C       DO PATH
C
         IF (INDEX(KEYWRD,'STEP').EQ.0.OR.
     1INDEX(KEYWRD,'POINT').EQ.0) THEN
            CALL PATHS
            GOTO 50
         ENDIF
         CALL PATHK
         GOTO 50
      ENDIF
      IF (   INDEX(KEYWRD,'FORCE') .NE. 0
     1  .OR. INDEX(KEYWRD,'IRC=' ) .NE. 0
     2  .OR. INDEX(KEYWRD,'THERM') .NE. 0 ) THEN
C
C FORCE CALCULATION IF DESIRED
C
         CALL FORCE
         GOTO 50
      ENDIF
      IF(INDEX(KEYWRD,' DRC') + INDEX(KEYWRD,' IRC') .NE. 0) THEN
C
C   IN THIS CONTEXT, "REACT" HOLDS INITIAL VELOCITY VECTOR COMPONENTS.
C
         CALL DRC(REACT,REACT)
         GOTO 50
      ENDIF
C
      IF(INDEX(KEYWRD,'NLLSQ') .NE. 0) THEN
         CALL NLLSQ(XPARAM, NVAR )
         CALL COMPFG(XPARAM,.TRUE.,ESCF,.TRUE.,GRAD,.TRUE.)
         GOTO 40
      ENDIF
C
      IF(INDEX(KEYWRD,'SIGMA') .NE. 0) THEN
         CALL POWSQ(XPARAM, NVAR, ESCF)
         GOTO 40
      ENDIF
C
C  EF OPTIMISATION
C
      IF(INDEX(KEYWRD,' EF').NE.0 .OR. INDEX(KEYWRD,' TS').NE.0) THEN
         IF(INDEX(KEYWRD,'GEO-OK').EQ.0.AND.NVAR.GT.3*NATOMS-6)THEN
            WRITE(6,'(A)')' EIGENVECTOR FOLLOWING IS NOT RECOMMENDED WHE
     1N'
            WRITE(6,'(A)')' MORE THAN 3N-6 COORDINATES ARE TO BE OPTIMIZ
     1ED'
            WRITE(6,'(A)')' TO CONTINUE, SPECIFY ''GEO-OK'''
            STOP
         ENDIF
         CALL EF (XPARAM,NVAR,ESCF)
         GOTO 40
      ENDIF
C
C ORDINARY GEOMETRY OPTIMISATION
C
C
C ORDINARY GEOMETRY OPTIMISATION
C
C#      CALL TIMER('BEFORE FLEPO')
      CALL FLEPO(XPARAM, NVAR, ESCF)
   40 LAST=1
      IF(IFLEPO.GE.0)CALL WRITE(TIME0, ESCF)
      IF(INDEX(KEYWRD,'POLAR') .NE. 0) THEN
         CALL POLAR
      ENDIF
      IF(INDEX(KEYWRD,' ESP') .NE. 0)THEN
C  IF YOU WANT TO USE THE ESP PROGRAM, UNCOMMENT THE LINE
C  "C#      CALL ESP", ADD "ESP, " TO MOPAC.OPT, THEN COMPILE ESP AND
C  MNDO, AND RELINK.
C
C
C  activate ESP.
C
        CALL ESP
      ENDIF
   50 TIM=SECOND()-TIME0
      LIMSCF=.FALSE.
      WRITE(6,'(///,'' TOTAL CPU TIME: '',F16.2,'' SECONDS'')') TIM
      WRITE(6,'(/,'' == MOPAC DONE =='')')
      IF(ISOK) GOTO 10
      END
